%    Copyright (C) 1996 Aladdin Enterprises.  All rights reserved.
% 
% This file is part of Aladdin Ghostscript.
% 
% Aladdin Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author
% or distributor accepts any responsibility for the consequences of using it,
% or for whether it serves any particular purpose or works at all, unless he
% or she says so in writing.  Refer to the Aladdin Ghostscript Free Public
% License (the "License") for full details.
% 
% Every copy of Aladdin Ghostscript must include a copy of the License,
% normally in a plain ASCII text file named PUBLIC.  The License grants you
% the right to copy, modify and redistribute Aladdin Ghostscript, but only
% under certain conditions described in the License.  Among other things, the
% License requires that the copyright notice and this notice be preserved on
% all copies.

% Type 42 font support code.

% Here are the BuildChar and BuildGlyph implementation for Type 42 fonts.
% The names %Type42BuildChar and %Type42BuildGlyph are known to the
% interpreter.  The real work is done in an operator:
%	<font> <code|name> <name> <charstring> .type42execchar -

(%Type42BuildChar) cvn	% <font> <code> %Type42BuildChar -
 { 1 index /Encoding get 1 index get .type42build
 } bind def
(%Type42BuildGlyph) cvn	% <font> <name> %Type42BuildGlyph -
 { dup .type42build
 } bind def
/.type42build		% <font> <code|name> <name> .type42build -
 { 2 index begin
    dup CharStrings exch .knownget not
     { 2 copy eq { exch pop /.notdef exch } if
       QUIET not
	{ (Substituting .notdef for ) print = flush }
	{ pop }
       ifelse
       /.notdef CharStrings /.notdef get
     } if
   end .type42execchar
 } bind def
