%    Copyright (C) 1994 Aladdin Enterprises.  All rights reserved.
% 
% This file is part of Aladdin Ghostscript.
% 
% Aladdin Ghostscript is distributed with NO WARRANTY OF ANY KIND.  No author
% or distributor accepts any responsibility for the consequences of using it,
% or for whether it serves any particular purpose or works at all, unless he
% or she says so in writing.  Refer to the Aladdin Ghostscript Free Public
% License (the "License") for full details.
% 
% Every copy of Aladdin Ghostscript must include a copy of the License,
% normally in a plain ASCII text file named PUBLIC.  The License grants you
% the right to copy, modify and redistribute Aladdin Ghostscript, but only
% under certain conditions described in the License.  Among other things, the
% License requires that the copyright notice and this notice be preserved on
% all copies.

% traceimg.ps
% Trace the data supplied to the 'image' operator.

% This code currently handles only the (Level 2) dictionary form of image,
% with a single data source and 8-bit pixels.

/traceimage			% <dict> traceimage -
 { currentcolorspace == (setcolorspace\n) print
   (<<) print
   dup { (\t) print exch ==only ( ) print == } forall
   (>>\n) print flush
   begin /i_left Width Height mul store /i_dict currentdict store end
    { i_left 0 le { exit } if
      i_dict /DataSource get exec
      dup type /filetype eq
       { i_buf 0 i_left 32 min getinterval readstring pop
       } if
      dup (%stdout) (w) file exch writehexstring (\n) print flush
      i_left exch length sub /i_left exch def
    } loop
 } bind odef

/image /traceimage load def
/i_left 0 def
/i_dict null def
/i_buf 32 string def
